config/routes.rb
require 'sidekiq/web'
require 'sidekiq/cron/web'

Rails.application.routes.draw do
  root 'pages#index'
  post 'send' => 'pages#create'
  get 'about' => 'pages#about'

  get 'gallery' => 'images#index'
  resources :images, except: [:index]

  resources :messages, except: [:show]
  get 'message' => 'messages#show', as: :show_message

  resources :slides, except: [:show]
  resources :announcements, :path => 'ans'
  resources :subscribers, only: [:create]
  get 'subs/:id' => 'subscribers#destroy', as: :subs_destroy

  get 'hashmin/login' => 'sessions#new', as: :login
  post 'hashmin/login' => 'sessions#create'
  get 'hashmin/logout' => 'sessions#destroy', as: :logout
  get 'hashmin/:id' => 'admins#index', as: :admin
  resources :admins, except: [:show], path: 'hashmin'

  resources :password_resets, only: [:new, :create, :edit, :update]

  mount Sidekiq::Web => '/sidekiq'

end

app/controllers/password_resets_controller.rb
class PasswordResetsController < ApplicationController
  def new
  end

  def create
    @admin = Admin.find_by(email: params[:password_reset][:email].downcase)
    if @admin
      @admin.reset_t
      @admin.send_reset
      flash[:success] = "Reset email has been sent."
      redirect_to root_path
    else
      flash[:danger] = "Email is not valid"
      render 'new'
    end
  end

  def edit
    @admin = Admin.find_by(email: params[:email])
    unless @admin && @admin.reset_digest == params[:id] && !@admin.expired?
      flash[:danger] = "The reset url is invalid or has expired."
      redirect_to new_password_reset_path
    end
  end

  def update
    @admin = Admin.find_by(email: params[:email])
    unless @admin && @admin.reset_digest == params[:id] && !@admin.expired?
      flash[:danger] = "The reset url is invalid or has expired."
      redirect_to new_password_reset_path
    end
    if params[:admin][:password].blank?
      flash.now[:danger] = "Password can't be blank"
      render 'edit'
    elsif @admin.update_attributes(admin_params)
      flash[:success] = "Password has been reset. Please log in."
      redirect_to root_path
    else
      render 'edit'
    end
  end

  private
    def admin_params
      params.require(:admin).permit(:password, :password_confirmation)
    end
end

app/helpers/password_resets_helper.rb
module PasswordResetsHelper
end

app/views/password_resets/edit.html.haml
= form_for(@admin, url: password_reset_path(params[:id])) do |f|
  = render 'shared/form_top'
  = render 'shared/errors', object: f.object
  = hidden_field_tag :email, @admin.email
  .field
    = f.label :password
    = f.password_field :password
  .field
    = f.label :password_confirmation, "Confirm"
    = f.password_field :password_confirmation
  = f.submit "Change password"

app/views/password_resets/new.html.haml
= form_for(:password_reset, url: password_resets_path) do |f|
  = render "shared/form_top"
  .field
    = f.label :email
    = f.email_field :email
  = f.submit "Send Reset Email"